d9a381791e0654e9e30ca1c30922b1f2fd081274
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash m4 autoconf ispell grep diff rcs cvs fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils"
53
54
55 # these libraries are built for the target environment, and are built after
56 # the host libraries and the host tools (which may be a cross compiler)
57 #
58 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
59
60
61 # these tools are built using the target libs, and are intended to run only
62 # in the target environment
63 #
64 # note: any program that *uses* libraries that are in the "target_libs"
65 # list belongs in this list. those programs are also very likely
66 # candidates for the "native_only" list which follows
67 #
68 target_tools="target-examples target-groff"
69
70 ################################################################################
71
72 ## These two lists are of directories that are to be removed from the
73 ## ${configdirs} list for either cross-compilations or for native-
74 ## compilations. For example, it doesn't make that much sense to
75 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
76 ## a native environment.
77
78 # directories to be built in the native environment only
79 #
80 # This must be a single line because of the way it is searched by grep in
81 # the code below.
82 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time bash prms"
83
84 # directories to be built in a cross environment only
85 #
86 cross_only="target-libiberty target-libgloss target-newlib"
87
88 ## All tools belong in one of the four categories, and are assigned above
89 ## We assign ${configdirs} this way to remove all embedded newlines. This
90 ## is important because configure will choke if they ever get through.
91 ## ${configdirs} is directories we build using the host tools.
92 ## ${target_configdirs} is directories we build using the target tools.
93 #
94 configdirs=`echo ${host_libs} ${host_tools}`
95 target_configdirs=`echo ${target_libs} ${target_tools}`
96
97 ################################################################################
98
99 srctrigger=move-if-change
100 srcname="gnu development package"
101
102 # This gets set non-empty for some net releases of packages.
103 appdirs=""
104
105 # per-host:
106
107 # Work in distributions that contain no compiler tools, like Autoconf.
108 if [ -d ${srcdir}/config ]; then
109 case "${host}" in
110 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
111 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
112 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
113 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
114 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
115 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
116 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
117 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
118 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
119 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
120 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
121 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
122 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
123 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
124 i[3456]86-*-dgux*) host_makefile_frag=config/mh-dgux386 ;;
125 i[3456]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
126 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
127 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
128 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
129 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
130 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
131 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
132 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
133 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
134 *-windows*) host_makefile_frag=config/mh-windows ;;
135 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
136 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
137 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
138 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
139 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
140 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
141 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
142 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
143 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
144 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
145 esac
146 fi
147
148 # If we aren't going to be using gcc, see if we can extract a definition
149 # of CC from the fragment.
150 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
151 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
152 found=
153 for dir in $PATH; do
154 test -z "$dir" && dir=.
155 if test -f $dir/gcc; then
156 found=yes
157 break
158 fi
159 done
160 IFS="$save_ifs"
161 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
162 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
163 if [ -n "${xx}" ] ; then
164 CC=$xx
165 fi
166 fi
167 fi
168
169 # We default to --with-shared on platforms where -fpic is meaningless.
170 # Well, we don't yet, but we will.
171 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
172 case "${target}" in
173 alpha-dec-osf*) enable_shared=yes ;;
174 alpha-*-linux*) enable_shared=yes ;;
175 mips-sgi-irix5*) enable_shared=yes ;;
176 *) enable_shared=no ;;
177 esac
178 fi
179
180 case "${enable_shared}" in
181 yes) shared=yes ;;
182 no) shared=no ;;
183 "") shared=no ;;
184 *) shared=yes ;;
185 esac
186
187 if [ x${shared} = xyes ]; then
188 waugh=
189 case "${host}" in
190 hppa*) waugh=config/mh-papic ;;
191 i[3456]86-*) waugh=config/mh-x86pic ;;
192 sparc64-*) waugh=config/mh-sparcpic ;;
193 *) waugh=config/mh-${host_cpu}pic ;;
194 esac
195 if [ -f ${srcdir}/${waugh} ]; then
196 if [ -n "${host_makefile_frag}" ] ; then
197 cat ${srcdir}/${host_makefile_frag} > mh-frag
198 cat ${srcdir}/${waugh} >> mh-frag
199 host_makefile_frag=mh-frag
200 else
201 host_makefile_frag=${waugh}
202 fi
203 fi
204 fi
205
206 # per-target:
207
208 case "${target}" in
209 v810*) target_makefile_frag=config/mt-v810 ;;
210 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
211 # start-sanitize-r5900
212 mips64vr5900*-*-*) target_makefile_frag=config/mt-r5900 ;;
213 # end-sanitize-r5900
214 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
215 esac
216
217 skipdirs=
218 gasdir=gas
219 use_gnu_ld=
220 use_gnu_as=
221
222 # some tools are so dependent upon X11 that if we're not building with X,
223 # it's not even worth trying to configure, much less build, that tool.
224
225 case ${with_x} in
226 yes | "") # the default value for this tree is that X11 is available
227 ;;
228 no)
229 skipdirs="${skipdirs} tk gash"
230 ;;
231 *)
232 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
233 ;;
234 esac
235
236 # Some tools are only suitable for building in a "native" situation.
237 # Those are added when we have a host==target configuration. For cross
238 # toolchains, we add some directories that should only be useful in a
239 # cross-compiler.
240
241 is_cross_compiler=
242
243 if [ x"${host}" = x"${target}" ] ; then
244 # when doing a native toolchain, don't build the targets
245 # that are in the 'cross only' list
246 skipdirs="${skipdirs} ${cross_only}"
247 is_cross_compiler=no
248 target_subdir=.
249 else
250 # similarly, don't build the targets in the 'native only'
251 # list when building a cross compiler
252 skipdirs="${skipdirs} ${native_only}"
253 is_cross_compiler=yes
254 target_subdir=${target_alias}
255 if [ ! -d ${target_subdir} ] ; then
256 if mkdir ${target_subdir} ; then true
257 else
258 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
259 exit 1
260 fi
261 fi
262 fi
263
264 copy_dirs=
265
266 # Handle --with-headers=XXX. The contents of the named directory are
267 # copied to $(tooldir)/sys-include.
268 if [ x"${with_headers}" != x ]; then
269 if [ x${is_cross_compiler} = xno ]; then
270 echo 1>&2 '***' --with-headers is only supported when cross compiling
271 exit 1
272 fi
273 case "${exec_prefixoption}" in
274 "") x=${prefix} ;;
275 *) x=${exec_prefix} ;;
276 esac
277 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
278 fi
279
280 # Handle --with-libs=XXX. Multiple directories are permitted. The
281 # contents are copied to $(tooldir)/lib.
282 if [ x"${with_libs}" != x ]; then
283 if [ x${is_cross_compiler} = xno ]; then
284 echo 1>&2 '***' --with-libs is only supported when cross compiling
285 exit 1
286 fi
287 # Copy the libraries in reverse order, so that files in the first named
288 # library override files in subsequent libraries.
289 case "${exec_prefixoption}" in
290 "") x=${prefix} ;;
291 *) x=${exec_prefix} ;;
292 esac
293 for l in ${with_libs}; do
294 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
295 done
296 fi
297
298 # If both --with-headers and --with-libs are specified, default to
299 # --without-newlib.
300 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
301 if [ x"${with_newlib}" = x ]; then
302 with_newlib=no
303 fi
304 fi
305
306 # Recognize --with-newlib/--without-newlib.
307 if [ x${with_newlib} = xno ]; then
308 skipdirs="${skipdirs} target-newlib"
309 elif [ x${with_newlib} = xyes ]; then
310 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
311 fi
312
313 # Default to using --with-stabs for certain targets.
314 if [ x${with_stabs} = x ]; then
315 case "${target}" in
316 mips*-*-irix6*)
317 ;;
318 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
319 with_stabs=yes;
320 withoptions="${withoptions} --with-stabs"
321 ;;
322 esac
323 fi
324
325 # Handle ${copy_dirs}
326 set fnord ${copy_dirs}
327 shift
328 while [ $# != 0 ]; do
329 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
330 :
331 else
332 echo Copying $1 to $2
333
334 # Use the install script to create the directory and all required
335 # parent directories.
336 if [ -d $2 ]; then
337 :
338 else
339 echo >config.temp
340 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
341 fi
342
343 # Copy the directory, assuming we have tar.
344 # FIXME: Should we use B in the second tar? Not all systems support it.
345 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
346
347 # It is the responsibility of the user to correctly adjust all
348 # symlinks. If somebody can figure out how to handle them correctly
349 # here, feel free to add the code.
350
351 echo $1 > $2/COPIED
352 fi
353 shift; shift
354 done
355
356 # Configure extra directories which are host specific
357
358 case "${host}" in
359 i[3456]86-*-go32*)
360 configdirs="$configdirs dosrel" ;;
361 *-cygwin32*)
362 configdirs="$configdirs dosrel" ;;
363 esac
364
365 # Remove more programs from consideration, based on the host or
366 # target this usually means that a port of the program doesn't
367 # exist yet.
368
369 noconfigdirs=""
370
371 case "${host}" in
372 i[3456]86-*-vsta)
373 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
374 ;;
375 i[3456]86-*-go32)
376 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
377 ;;
378 *-*-cygwin32)
379 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
380 ;;
381 *-*-windows*)
382 # This is only used to build WinGDB...
383 configdirs="bfd gdb libiberty opcodes readline sim"
384 target_configdirs=
385 ;;
386 ppc*-*-pe)
387 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
388 ;;
389 esac
390
391
392 case "${target}" in
393 *-*-netware)
394 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
395 ;;
396 *-*-vxworks*)
397 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
398 ;;
399 alpha-dec-osf*)
400 # ld works, but does not support shared libraries. emacs doesn't
401 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
402 # gas doesn't generate exception information.
403 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
404 ;;
405 alpha*-*-*vms*)
406 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
407 ;;
408 alpha*-*-*)
409 # newlib is not 64 bit ready
410 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
411 ;;
412 # start-sanitize-arc
413 arc-*-*)
414 noconfigdirs="$noconfigdirs target-libgloss"
415 ;;
416 # end-sanitize-arc
417 arm-*-pe*)
418 noconfigdirs="$noconfigdirs target-libgloss"
419 ;;
420 arm-*-coff*)
421 noconfigdirs="$noconfigdirs target-libgloss"
422 ;;
423 arm-*-riscix*)
424 noconfigdirs="$noconfigdirs ld target-libgloss"
425 ;;
426 # start-sanitize-d10v
427 d10v-*-*)
428 noconfigdirs="$noconfigdirs target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
429 ;;
430 # end-sanitize-d10v
431 # start-sanitize-d30v
432 d30v-*-*)
433 noconfigdirs="$noconfigdirs sim tcl tk expect gcc gdb newlib ld target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
434 ;;
435 # end-sanitize-d30v
436 h8300*-*-* | \
437 h8500-*-*)
438 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
439 ;;
440 hppa*-*-*elf* | \
441 hppa*-*-lites*)
442 # Do configure ld/binutils/gas for this case.
443 ;;
444 hppa*-*-*)
445 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
446 # cc is gcc, and on any system a user should be able to link cc to
447 # whatever they want. FIXME, emacs emacs19).
448 case "${CC}" in
449 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
450 *) ;;
451 esac
452 noconfigdirs="$noconfigdirs ld shellutils"
453 ;;
454 i[3456]86-*-go32)
455 # but don't build gdb
456 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
457 ;;
458 *-*-cygwin32)
459 target_configdirs="$target_configdirs target-winsup"
460 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
461 # always build newlib.
462 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
463
464 # Can't build gdb for cygwin32 if not native.
465 case "${host}" in
466 *-*-cygwin32) ;; # keep gdb
467 *) noconfigdirs="$noconfigdirs gdb"
468 esac
469 ;;
470 i[3456]86-*-pe)
471 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
472 ;;
473 i[3456]86-*-sco3.2v5*)
474 # The linker does not yet know about weak symbols in COFF,
475 # and is not configured to handle mixed ELF and COFF.
476 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
477 ;;
478 i[3456]86-*-sco*)
479 noconfigdirs="$noconfigdirs gprof target-libgloss"
480 ;;
481 i[3456]86-*-solaris2*)
482 # The linker does static linking correctly, but the Solaris C library
483 # has bugs such that some important functions won't work when statically
484 # linked. (See man pages for getpwuid, for example.)
485 noconfigdirs="$noconfigdirs ld target-libgloss"
486 ;;
487 i[3456]86-*-sysv4*)
488 # The SYSV4 C compiler doesn't handle Emacs correctly
489 case "${CC}" in
490 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
491 *) ;;
492 esac
493 # but that's okay since emacs doesn't work anyway
494 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
495 ;;
496 mn10200-*-*)
497 noconfigdirs="$noconfigdirs target-libgloss"
498 ;;
499 mn10300-*-*)
500 noconfigdirs="$noconfigdirs target-libgloss"
501 ;;
502 powerpc-*-aix*)
503 # copied from rs6000-*-* entry
504 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
505 # This is needed until gcc and ld are fixed to work together.
506 use_gnu_ld=no
507 ;;
508 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
509 target_configdirs="$target_configdirs target-winsup"
510 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
511 # always build newlib.
512 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
513 ;;
514 # This is temporary until we can link against shared libraries
515 powerpcle-*-solaris*)
516 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
517 ;;
518 rs6000-*-lynxos*)
519 # The CVS server code doesn't work on the RS/6000
520 # Newlib makes problems for libg++ in crosses.
521 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
522 ;;
523 rs6000-*-aix*)
524 noconfigdirs="$noconfigdirs gprof"
525 # This is needed until gcc and ld are fixed to work together.
526 use_gnu_ld=no
527 ;;
528 rs6000-*-*)
529 noconfigdirs="$noconfigdirs gprof"
530 ;;
531 m68k-apollo-*)
532 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
533 ;;
534 mips*-*-irix5*)
535 # The GNU linker does not support shared libraries.
536 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
537 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
538 ;;
539 mips*-*-irix6*)
540 # The GNU linker does not support shared libraries.
541 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
542 noconfigdirs="$noconfigdirs ld gas gprof emacs target-libgloss"
543 ;;
544 mips*-dec-bsd*)
545 noconfigdirs="$noconfigdirs gprof target-libgloss"
546 ;;
547 mips*-*-bsd*)
548 noconfigdirs="$noconfigdirs gprof target-libgloss"
549 ;;
550 mips*-*-*)
551 noconfigdirs="$noconfigdirs gprof"
552 ;;
553 romp-*-*)
554 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
555 ;;
556 sh-*-*)
557 case "${host}" in
558 i[3456]86-*-vsta) ;; # don't add gprof back in
559 i[3456]86-*-go32) ;; # don't add gprof back in
560 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
561 esac
562 noconfigdirs="$noconfigdirs target-libgloss"
563 ;;
564 sparc-*-sunos4*)
565 if [ x${is_cross_compiler} != xno ] ; then
566 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
567 else
568 use_gnu_ld=no
569 fi
570 ;;
571 # start-sanitize-tic80
572 tic80-*-*)
573 noconfigdirs="$noconfigdirs gcc gdb ld target-libio target-libg++ target-libstdc++ target-libgloss"
574 ;;
575 # end-sanitize-tic80
576 v810-*-*)
577 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
578 ;;
579 # start-sanitize-v850
580 v850-*-*)
581 noconfigdirs="$noconfigdirs target-libgloss"
582 ;;
583 # end-sanitize-v850
584 vax-*-vms)
585 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
586 ;;
587 vax-*-*)
588 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
589 ;;
590 *-*-lynxos*)
591 # Newlib makes problems for libg++ in crosses.
592 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
593 ;;
594 *-*-macos* | \
595 *-*-mpw*)
596 # Macs want a resource compiler.
597 configdirs="$configdirs grez"
598 ;;
599 esac
600
601 # targets that need a second pass
602 case "${target}" in
603 *-gm-magic*)
604 noconfigdirs="$noconfigdirs target-libgloss"
605 ;;
606 esac
607
608 # If we aren't building newlib, then don't build libgloss, since libgloss
609 # depends upon some newlib header files.
610 case "${noconfigdirs}" in
611 *target-libgloss*) ;;
612 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
613 esac
614
615 # If we are building a Canadian Cross, discard tools that can not be built
616 # using a cross compiler. FIXME: These tools should be fixed.
617 if [ "${build}" != "${host}" ]; then
618 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
619 fi
620
621 # Make sure we don't let GNU ld be added if we didn't want it.
622 if [ x$with_gnu_ld = xno ]; then
623 use_gnu_ld=no
624 noconfigdirs="$noconfigdirs ld"
625 fi
626
627 # Make sure we don't let GNU as be added if we didn't want it.
628 if [ x$with_gnu_as = xno ]; then
629 use_gnu_as=no
630 noconfigdirs="$noconfigdirs gas"
631 fi
632
633 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
634 # $target_configdirs.
635 # If we have the source for $noconfigdirs entries, add them to $notsupp.
636
637 notsupp=""
638 for dir in . $skipdirs $noconfigdirs ; do
639 dirname=`echo $dir | sed -e s/target-//g`
640 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
641 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
642 if [ -r $srcdir/$dirname/configure ] \
643 || [ -r $srcdir/$dirname/configure.in ]; then
644 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
645 true
646 else
647 notsupp="$notsupp $dir"
648 fi
649 fi
650 fi
651 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
652 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
653 if [ -r $srcdir/$dirname/configure ] \
654 || [ -r $srcdir/$dirname/configure.in ]; then
655 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
656 true
657 else
658 notsupp="$notsupp $dir"
659 fi
660 fi
661 fi
662 done
663
664 # Sometimes the tools are distributed with libiberty but with no other
665 # libraries. In that case, we don't want to build target-libiberty.
666 if [ -n "${target_configdirs}" ]; then
667 others=
668 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
669 if [ "$i" != "libiberty" ]; then
670 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
671 others=yes;
672 break;
673 fi
674 fi
675 done
676 if [ -z "${others}" ]; then
677 target_configdirs=
678 fi
679 fi
680
681 # Deconfigure all subdirectories, in case we are changing the
682 # configuration from one where a subdirectory is supported to one where it
683 # is not.
684 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
685 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
686 rm -f $i/Makefile
687 done
688 fi
689 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
690 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
691 rm -f ${target_subdir}/$i/Makefile
692 done
693 fi
694
695 # Produce a warning message for the subdirs we can't configure.
696 # This isn't especially interesting in the Cygnus tree, but in the individual
697 # FSF releases, it's important to let people know when their machine isn't
698 # supported by the one or two programs in a package.
699
700 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
701 # If $appdirs is non-empty, at least one of those directories must still
702 # be configured, or we error out. (E.g., if the gas release supports a
703 # specified target in some subdirs but not the gas subdir, we shouldn't
704 # pretend that all is well.)
705 if [ -n "$appdirs" ]; then
706 for dir in $appdirs ; do
707 if [ -r $dir/Makefile.in ]; then
708 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
709 appdirs=""
710 break
711 fi
712 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
713 appdirs=""
714 break
715 fi
716 fi
717 done
718 if [ -n "$appdirs" ]; then
719 echo "*** This configuration is not supported by this package." 1>&2
720 exit 1
721 fi
722 fi
723 # Okay, some application will build, or we don't care to check. Still
724 # notify of subdirs not getting built.
725 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
726 echo " ${notsupp}" 1>&2
727 echo " (Any other directories should still work fine.)" 1>&2
728 fi
729
730 # Set with_gnu_as and with_gnu_ld as appropriate.
731 #
732 # This is done by determining whether or not the appropriate directory
733 # is available, and by checking whether or not specific configurations
734 # have requested that this magic not happen.
735 #
736 # The command line options always override the explicit settings in
737 # configure.in, and the settings in configure.in override this magic.
738 #
739 # If the default for a toolchain is to use GNU as and ld, and you don't
740 # want to do that, then you should use the --without-gnu-as and
741 # --without-gnu-ld options for the configure script.
742
743 if [ x${use_gnu_as} = x ] ; then
744 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
745 with_gnu_as=yes
746 withoptions="$withoptions --with-gnu-as"
747 fi
748 fi
749
750 if [ x${use_gnu_ld} = x ] ; then
751 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
752 with_gnu_ld=yes
753 withoptions="$withoptions --with-gnu-ld"
754 fi
755 fi
756
757 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
758 # can detect this case.
759
760 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
761 with_newlib=yes
762 withoptions="$withoptions --with-newlib"
763 fi
764
765 if [ x${shared} = xyes ]; then
766 case "${target}" in
767 hppa*) target_makefile_frag=config/mt-papic ;;
768 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
769 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
770 esac
771 fi
772
773 # post-target:
774
775 # Make sure that the compiler is able to generate an executable. If it
776 # can't, we are probably in trouble. We don't care whether we can run the
777 # executable--we might be using a cross compiler--we only care whether it
778 # can be created. At this point the main configure script has set CC.
779 echo "int main () { return 0; }" > conftest.c
780 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
781 if [ $? = 0 ] && [ -s conftest ]; then
782 :
783 else
784 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
785 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
786 rm -f conftest*
787 exit 1
788 fi
789 rm -f conftest*
790
791 # The Solaris /usr/ucb/cc compiler does not appear to work.
792 case "${host}" in
793 sparc-sun-solaris2*)
794 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
795 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
796 could_use=
797 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
798 if [ -d /opt/cygnus/bin ] ; then
799 if [ "$could_use" = "" ] ; then
800 could_use="/opt/cygnus/bin"
801 else
802 could_use="$could_use or /opt/cygnus/bin"
803 fi
804 fi
805 if [ "$could_use" = "" ] ; then
806 echo "Warning: compilation may fail because you're using"
807 echo "/usr/ucb/cc. You should change your PATH or CC "
808 echo "variable and rerun configure."
809 else
810 echo "Warning: compilation may fail because you're using"
811 echo "/usr/ucb/cc, when you should use the C compiler from"
812 echo "$could_use. You should change your"
813 echo "PATH or CC variable and rerun configure."
814 fi
815 fi
816 ;;
817 esac
818
819 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
820 # binutils tools will find libbfd.so.
821 if [ "${shared}" = "yes" ]; then
822 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
823 Makefile > Makefile.tem
824 rm -f Makefile
825 mv -f Makefile.tem Makefile
826
827 case "${host}" in
828 *-*-hpux*)
829 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
830 Makefile > Makefile.tem
831 rm -f Makefile
832 mv -f Makefile.tem Makefile
833 ;;
834 esac
835 fi
836
837 # Record target_configdirs and the configure arguments in Makefile.
838 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
839 targargs=`echo "${arguments}" | \
840 sed -e 's/--norecursion//' \
841 -e 's/--cache[a-z-]*=[^ ]*//' \
842 -e 's/--ho[a-z-]*=[^ ]*//' \
843 -e 's/--ta[a-z-]*=[^ ]*//'`
844
845 # Passing a --with-cross-host argument lets the target libraries know
846 # whether they are being built with a cross-compiler or being built
847 # native. However, it would be better to use other mechanisms to make the
848 # sorts of decisions they want to make on this basis. Please consider
849 # this option to be deprecated. FIXME.
850 if [ x${is_cross_compiler} = xyes ]; then
851 targargs="--with-cross-host=${host_alias} ${targargs}"
852 fi
853
854 targargs="--host=${target_alias} ${targargs}"
855 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
856 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
857 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
858 Makefile > Makefile.tem
859 rm -f Makefile
860 mv -f Makefile.tem Makefile
861
862 #
863 # Local Variables:
864 # fill-column: 131
865 # End:
866 #
This page took 0.072822 seconds and 4 git commands to generate.